#ifndef CONSOLAWF2MATC_H
#define CONSOLAWF2MATC_H

#include "genfile.h"

class con_awf2matc
{
 public:
  con_awf2matc();    //constructor
  ~con_awf2matc();   //destructor

  void read(XFILE *in);
  void print(FILE *out);

  void matcond_u (matrix &d,long ri,long ci,long ipp);
  void matcap_u (matrix &d,long ri,long ci,long ipp);
  void matcond1d_u (matrix &d,long ri,long ci,long ipp);
  void matcond2d_u (matrix &d,long ri,long ci,long ipp);
  void matcond3d_u (matrix &d,long ri,long ci,long ipp);
  void matcap1d_u (matrix &d,long ri,long ci,long ipp);
  void matcap2d_u (matrix &d,long ri,long ci,long ipp);
  void matcap3d_u (matrix &d,long ri,long ci,long ipp);

  void matcond_l (matrix &d,long ri,long ci,long ipp);
  void matcap_l (matrix &d,long ri,long ci,long ipp);
  void matcond1d_l (matrix &d,long ri,long ci,long ipp);
  void matcond2d_l (matrix &d,long ri,long ci,long ipp);
  void matcond3d_l (matrix &d,long ri,long ci,long ipp);
  void matcap1d_l (matrix &d,long ri,long ci,long ipp);
  void matcap2d_l (matrix &d,long ri,long ci,long ipp);
  void matcap3d_l (matrix &d,long ri,long ci,long ipp);

  void rhs_volume (matrix &d,long ri,long ci,long ipp);
  void rhs1d1 (matrix &d,long ri,long ci,long ipp);
  void rhs2d1 (matrix &d,long ri,long ci,long ipp);
  void rhs3d1 (matrix &d,long ri,long ci,long ipp);

  double get_sw(double pw, double pg);
  double get_cs(double pw, double pg);
  double get_se(double sw);
  double get_krl(double pw, double pg);
  double get_krg(double pw, double pg);
  double get_phi();
  double get_kintr();
  double get_rhos();
  double get_alpha();
  double get_emod();
  double get_nu();
  double get_ks();
  double get_kw();
  double get_muw();

  double get_kuw(double pw, double pg);
  double get_kwu(double pw, double pg);

  double get_kug(double pw, double pg);
  double get_kgu(double pw, double pg);

  double get_kww(double pw, double pg);
  double get_kwg(double pw, double pg);
  double get_kgw(double pw, double pg);
  double get_kgg(double pw, double pg);

  double get_capuw(double pw, double pg);
  double get_capwu(double pw, double pg);

  double get_capug(double pw, double pg);
  double get_capgu(double pw, double pg);

  double get_capww(double pw, double pg);
  double get_capwg(double pw, double pg);
  double get_capgw(double pw, double pg);
  double get_capgg(double pw, double pg);

  double get_fw1(double pw, double pg);
  double get_fg1(double pw, double pg);
  double get_fu1(double pw, double pg);

 private:
  
  double emod,nu,alpha,ks,phi0,rhos,kw,rhow,muw0,kintr,mug,patm,temp;

};  

#endif
